Index: /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/LinearTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/LinearTransformation.cs	(revision 10776)
+++ /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/LinearTransformation.cs	(revision 10777)
@@ -34,28 +34,28 @@
   [Item("LinearTransformation", "Represents a linear transformation with multiplication and addition.")]
   public class LinearTransformation : Transformation<double> {
-    protected const string MultiplicandParameterName = "Multiplicand";
-    protected const string SummandParameterName = "Summand";
+    protected const string MultiplierParameterName = "Multiplier";
+    protected const string AddendParameterName = "Addend";
 
     #region Parameters
-    public IValueParameter<DoubleValue> MultiplicandParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[MultiplicandParameterName]; }
+    public IValueParameter<DoubleValue> MultiplierParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[MultiplierParameterName]; }
     }
-    public IValueParameter<DoubleValue> SummandParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[SummandParameterName]; }
+    public IValueParameter<DoubleValue> AddendParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[AddendParameterName]; }
     }
     #endregion
 
     #region properties
-    public double Multiplicand {
-      get { return MultiplicandParameter.Value.Value; }
+    public double Multiplier {
+      get { return MultiplierParameter.Value.Value; }
       protected set {
-        MultiplicandParameter.Value.Value = value;
+        MultiplierParameter.Value.Value = value;
       }
     }
 
-    public double Summand {
-      get { return SummandParameter.Value.Value; }
+    public double Addend {
+      get { return AddendParameter.Value.Value; }
       protected set {
-        SummandParameter.Value.Value = value;
+        AddendParameter.Value.Value = value;
       }
     }
@@ -71,6 +71,6 @@
     public LinearTransformation(IEnumerable<string> allowedColumns)
       : base(allowedColumns) {
-      Parameters.Add(new ValueParameter<DoubleValue>(MultiplicandParameterName, "Multiplicand for linear transformation", new DoubleValue(1.0)));
-      Parameters.Add(new ValueParameter<DoubleValue>(SummandParameterName, "Summand for linear transformation", new DoubleValue(0.0)));
+      Parameters.Add(new ValueParameter<DoubleValue>(MultiplierParameterName, "Multiplier for linear transformation", new DoubleValue(1.0)));
+      Parameters.Add(new ValueParameter<DoubleValue>(AddendParameterName, "Addend for linear transformation", new DoubleValue(0.0)));
     }
 
@@ -80,5 +80,5 @@
 
     public override IEnumerable<double> Apply(IEnumerable<double> data) {
-      return data.Select(e => e * Multiplicand + Summand);
+      return data.Select(e => e * Multiplier + Addend);
     }
 
@@ -88,6 +88,6 @@
       errorMsg = null;
 
-      if (Multiplicand == 0.0) {
-        sb.Append(String.Format("Multiplicand is 0, all {0} entries will be set to {1}. Reversal will not be possble", data.Count(), Summand));
+      if (Multiplier == 0.0) {
+        sb.Append(String.Format("Multiplicand is 0, all {0} entries will be set to {1}. Reversal will not be possble", data.Count(), Addend));
         errorMsg = sb.ToString();
         success = false;
Index: /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftDataToRangeTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftDataToRangeTransformation.cs	(revision 10776)
+++ /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftDataToRangeTransformation.cs	(revision 10777)
@@ -34,6 +34,6 @@
     public ShiftDataToRangeTransformation(IEnumerable<string> allowedColumns)
       : base(allowedColumns) {
-      MultiplicandParameter.Hidden = true;
-      SummandParameter.Hidden = true;
+      MultiplierParameter.Hidden = true;
+      AddendParameter.Hidden = true;
       Parameters.Add(new ValueParameter<DoubleRange>(RangeParameterName, "Range for the target window of the linear transformation", new DoubleRange(0.0, 1.0)));
     }
@@ -60,6 +60,6 @@
       double targetRangeWidth = Range.End - Range.Start;
 
-      Multiplicand = targetRangeWidth / originalRangeWidth;
-      Summand = Range.Start - originalRangeStart * Multiplicand;
+      Multiplier = targetRangeWidth / originalRangeWidth;
+      Addend = Range.Start - originalRangeStart * Multiplier;
     }
   }