Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/CheckedTransformationCollectionView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/CheckedTransformationCollectionView.cs	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/CheckedTransformationCollectionView.cs	(revision 10786)
@@ -52,6 +52,8 @@
       if (typeSelectorDialog.ShowDialog(this) == DialogResult.OK) {
         try {
-          var columNames = new[] { "dummy", "target" }.AsEnumerable();
-          return (ITransformation)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType(new[] { columNames });
+          // TODO:
+          var columnNames = Enumerable.Range(0, 10).Select(i => "x" + i);
+          //var columnNames = new[] { "dummy", "target" }.AsEnumerable();
+          return (ITransformation)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType(new[] { columnNames });
         } catch (Exception ex) {
           ErrorHandling.ShowErrorDialog(this, ex);
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs	(revision 10786)
@@ -47,15 +47,32 @@
     /// </summary>
     private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
-      this.transformationCollectionView = new CheckedTransformationCollectionView();
+      this.transformationCollectionView = new HeuristicLab.DataPreprocessing.Views.CheckedTransformationCollectionView();
+      this.applyButton = new System.Windows.Forms.Button();
+      this.SuspendLayout();
+      // 
       // transformationCollectionView
       // 
+      this.transformationCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.transformationCollectionView.Caption = "Transformations";
       this.transformationCollectionView.Content = null;
-      this.transformationCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
       this.transformationCollectionView.Location = new System.Drawing.Point(0, 0);
       this.transformationCollectionView.Name = "transformationCollectionView";
-      this.transformationCollectionView.Size = new System.Drawing.Size(627, 528);
+      this.transformationCollectionView.ReadOnly = false;
+      this.transformationCollectionView.ShowDetails = true;
+      this.transformationCollectionView.Size = new System.Drawing.Size(627, 482);
       this.transformationCollectionView.TabIndex = 0;
+      // 
+      // applyButton
+      // 
+      this.applyButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.applyButton.Location = new System.Drawing.Point(490, 488);
+      this.applyButton.Name = "applyButton";
+      this.applyButton.Size = new System.Drawing.Size(134, 23);
+      this.applyButton.TabIndex = 1;
+      this.applyButton.Text = "Apply Transformations";
+      this.applyButton.UseVisualStyleBackColor = true;
+      this.applyButton.Click += new System.EventHandler(this.applyButton_Click);
       // 
       // TransformationView
@@ -63,7 +80,8 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.applyButton);
       this.Controls.Add(this.transformationCollectionView);
       this.Name = "TransformationView";
-      this.Size = new System.Drawing.Size(627, 528);
+      this.Size = new System.Drawing.Size(627, 514);
       this.ResumeLayout(false);
 
@@ -72,4 +90,5 @@
     #endregion
     private CheckedTransformationCollectionView transformationCollectionView;
+    private System.Windows.Forms.Button applyButton;
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10786)
@@ -20,7 +20,7 @@
 #endregion
 
+using System;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing.Views {
@@ -29,4 +29,5 @@
   [Content(typeof(TransformationContent), true)]
   public partial class TransformationView : AsynchronousContentView {
+
     public TransformationView() {
       InitializeComponent();
@@ -46,4 +47,14 @@
       }
     }
+
+    private void applyButton_Click(object sender, EventArgs e) {
+      var transformations = Content.CheckedTransformationCollection.CheckedItems;
+
+      var transformator = new PreprocessingTransformator(Content.Data);
+      bool success = transformator.ApplyTransformations(transformations);
+      if (success) {
+        Content.CheckedTransformationCollection.Clear();
+      }
+    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10786)
@@ -78,4 +78,5 @@
     <Compile Include="Implementations\DataGridLogic.cs" />
     <Compile Include="Interfaces\IFilteredPreprocessingData.cs" />
+    <Compile Include="PreprocessingTransformator.cs" />
     <Compile Include="Utils\DataPreprocessingChangedEvent.cs" />
     <Compile Include="Implementations\Filter\ComparisonFilter.cs" />
@@ -91,5 +92,4 @@
     <Compile Include="Implementations\StatisticsContent.cs" />
     <Compile Include="Implementations\TransformationContent.cs" />
-    <Compile Include="Implementations\TransformationLogic.cs" />
     <Compile Include="Interfaces\IFilterLogic.cs" />
     <Compile Include="Interfaces\IChartLogic.cs" />
@@ -178,7 +178,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="Implementations\Transformations\" />
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingContext.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingContext.cs	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingContext.cs	(revision 10786)
@@ -23,9 +23,6 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
-using Variable = HeuristicLab.Problems.DataAnalysis.Symbolic.Variable;
 using HeuristicLab.DataPreprocessing.Implementations;
 using HeuristicLab.DataPreprocessing.Interfaces;
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10785)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10786)
@@ -52,5 +52,7 @@
     public PreprocessingData(IDataAnalysisProblemData problemData)
       : base() {
-      Name = "-";
+      Name = "Preprocessing Data";
+
+      transformations = new List<ITransformation>();
 
       variableNames = new List<string>(problemData.Dataset.VariableNames);
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationLogic.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationLogic.cs	(revision 10785)
+++ 	(revision )
@@ -1,38 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-namespace HeuristicLab.DataPreprocessing {
-
-  public class TransformationLogic : ITransformationLogic {
-
-    private readonly ITransactionalPreprocessingData preprocessingData;
-    private readonly ISearchLogic searchLogic;
-    private readonly IStatisticsLogic statisticsLogic;
-
-    public TransformationLogic(ITransactionalPreprocessingData thePreprocessingData, ISearchLogic theSearchLogic, IStatisticsLogic theStatisticsLogic) {
-      preprocessingData = thePreprocessingData;
-      searchLogic = theSearchLogic;
-      statisticsLogic = theStatisticsLogic;
-    }
-
-  }
-}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs	(revision 10786)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs	(revision 10786)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
+
+namespace HeuristicLab.DataPreprocessing {
+  public class PreprocessingTransformator {
+    private readonly ITransactionalPreprocessingData preprocessingData;
+
+    public PreprocessingTransformator(IPreprocessingData preprocessingData) {
+      this.preprocessingData = (ITransactionalPreprocessingData)preprocessingData;
+    }
+
+    public bool ApplyTransformations(IEnumerable<ITransformation> transformations) {
+      bool success = true;
+
+      preprocessingData.InTransaction(() => {
+        var doubleTransformations = transformations.OfType<Transformation<double>>().ToList();
+        ApplyDoubleTranformations(doubleTransformations, out success);
+      }, DataPreprocessingChangedEventType.Transformation);
+
+      if (!success) {
+        // TODO: check undo remove transformations
+        preprocessingData.Undo();
+      }
+
+      return success;
+    }
+
+    private void ApplyDoubleTranformations(IEnumerable<Transformation<double>> transformations, out bool success) {
+      foreach (var transformation in transformations) {
+        int colIndex = preprocessingData.GetColumnIndex(transformation.Column);
+
+        var originalData = preprocessingData.GetValues<double>(colIndex);
+        var transformedData = ApplyDoubleTransformation(transformation, originalData, out success);
+        if (!success) return;
+
+        preprocessingData.SetValues(colIndex, transformedData.ToList());
+        preprocessingData.Transformations.Add(transformation);
+      }
+      success = true;
+    }
+
+    private IEnumerable<double> ApplyDoubleTransformation(Transformation<double> transformation, IEnumerable<double> data, out bool success) {
+      string errorMsg;
+      if (transformation.Check(data, out errorMsg)) {
+        success = true;
+        return transformation.Apply(data);
+      }
+      throw new NotImplementedException("Display Check Result");
+    }
+  }
+}