Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs	(revision 10811)
@@ -91,14 +91,14 @@
           break;
         case 1: //Average
-          Content.ManipulationLogic.ReplaceIndicesByAverageValue(cells, false);
+          Content.ManipulationLogic.ReplaceIndicesByAverageValue(cells);
           break;
         case 2: //Median
-          Content.ManipulationLogic.ReplaceIndicesByMedianValue(cells, false);
+          Content.ManipulationLogic.ReplaceIndicesByMedianValue(cells);
           break;
         case 3: //Most Common
-          Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(cells, false);
+          Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(cells);
           break;
         case 4: //Random
-          Content.ManipulationLogic.ReplaceIndicesByRandomValue(cells, false);
+          Content.ManipulationLogic.ReplaceIndicesByRandomValue(cells);
           break;
       }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs	(revision 10811)
@@ -141,11 +141,11 @@
         logic.GetColumnTypeAsString(columnIndex),
         logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<double>(columnIndex, false).ToString(),
-        logic.GetMax<double>(columnIndex, false).ToString(),
-        logic.GetMedian(columnIndex, false).ToString(),
-        logic.GetAverage(columnIndex, false).ToString(),
+        logic.GetMin<double>(columnIndex).ToString(),
+        logic.GetMax<double>(columnIndex).ToString(),
+        logic.GetMedian(columnIndex).ToString(),
+        logic.GetAverage(columnIndex).ToString(),
         logic.GetStandardDeviation(columnIndex).ToString(),
         logic.GetVariance(columnIndex).ToString(),
-        logic.GetMostCommonValue<double>(columnIndex, false).ToString(),
+        logic.GetMostCommonValue<double>(columnIndex).ToString(),
         logic.GetDifferentValuesCount<double>(columnIndex).ToString()
       };
@@ -163,5 +163,5 @@
         "", //standard deviation
         "", //variance
-        logic.GetMostCommonValue<string>(columnIndex, false).ToString(),
+        logic.GetMostCommonValue<string>(columnIndex).ToString(),
         logic.GetDifferentValuesCount<string>(columnIndex).ToString()
       };
@@ -173,11 +173,11 @@
         logic.GetColumnTypeAsString(columnIndex),
         logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<DateTime>(columnIndex, false).ToString(),
-        logic.GetMax<DateTime>(columnIndex, false).ToString(),
-        logic.GetMedianDateTime(columnIndex, false).ToString(), 
-        logic.GetAverageDateTime(columnIndex, false).ToString(),
+        logic.GetMin<DateTime>(columnIndex).ToString(),
+        logic.GetMax<DateTime>(columnIndex).ToString(),
+        logic.GetMedianDateTime(columnIndex).ToString(), 
+        logic.GetAverageDateTime(columnIndex).ToString(),
         logic.GetStandardDeviation(columnIndex).ToString(),
         logic.GetVariance(columnIndex).ToString(), //variance
-        logic.GetMostCommonValue<DateTime>(columnIndex, false).ToString(),
+        logic.GetMostCommonValue<DateTime>(columnIndex).ToString(),
         logic.GetDifferentValuesCount<DateTime>(columnIndex).ToString()
       };
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ChartLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ChartLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ChartLogic.cs	(revision 10811)
@@ -37,5 +37,5 @@
 
     public DataRow CreateDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
-      IList<double> values = preprocessingData.GetValues<double>(variableName, false);
+      IList<double> values = preprocessingData.GetValues<double>(variableName);
       DataRow row = new DataRow(variableName, "", values);
       row.VisualProperties.ChartType = chartType;
@@ -44,5 +44,5 @@
 
     public DataRow CreateDataRowRange(string variableName,int start, int end, DataRowVisualProperties.DataRowChartType chartType) {
-      IList<double> values = preprocessingData.GetValues<double>(variableName, false);
+      IList<double> values = preprocessingData.GetValues<double>(variableName);
       IList<double> valuesRange = new List<double>();
       for (int i = 0; i < values.Count; i++) {
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ManipulationLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ManipulationLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/ManipulationLogic.cs	(revision 10811)
@@ -104,7 +104,7 @@
           int countValues = 0;
           if (preprocessingData.IsType<double>(column.Key)) {
-            countValues = preprocessingData.GetValues<double>(column.Key, false).Count();
-          } else if (preprocessingData.IsType<DateTime>(column.Key)) {
-            countValues = preprocessingData.GetValues<DateTime>(column.Key, false).Count();
+            countValues = preprocessingData.GetValues<double>(column.Key).Count();
+          } else if (preprocessingData.IsType<DateTime>(column.Key)) {
+            countValues = preprocessingData.GetValues<DateTime>(column.Key).Count();
           }
 
@@ -256,5 +256,5 @@
     private void reOrderToIndices<T>(int columnIndex, IList<Tuple<int, int>> indices) {
 
-      List<T> originalData = new List<T>(preprocessingData.GetValues<T>(columnIndex, false));
+      List<T> originalData = new List<T>(preprocessingData.GetValues<T>(columnIndex));
 
       // process all columns equally
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/StatisticsLogic.cs	(revision 10811)
@@ -129,7 +129,7 @@
       double stdDev = double.NaN;
       if (preprocessingData.IsType<double>(columnIndex)) {
-        stdDev = GetValuesWithoutNaN<double>(columnIndex, false).StandardDeviation();
+        stdDev = GetValuesWithoutNaN<double>(columnIndex).StandardDeviation();
       } else if (preprocessingData.IsType<DateTime>(columnIndex)) {
-        stdDev = GetDateTimeAsSeconds(columnIndex, false).StandardDeviation();
+        stdDev = GetDateTimeAsSeconds(columnIndex).StandardDeviation();
       }
       return stdDev;
@@ -139,7 +139,7 @@
       double variance = double.NaN;
       if (preprocessingData.IsType<double>(columnIndex)) {
-        variance = preprocessingData.GetValues<double>(columnIndex, false).Variance();
+        variance = preprocessingData.GetValues<double>(columnIndex).Variance();
       } else if (preprocessingData.IsType<DateTime>(columnIndex)) {
-        variance = GetDateTimeAsSeconds(columnIndex, false).Variance();
+        variance = GetDateTimeAsSeconds(columnIndex).Variance();
       }
       return variance;
@@ -147,5 +147,5 @@
 
     public int GetDifferentValuesCount<T>(int columnIndex) {
-      return preprocessingData.GetValues<T>(columnIndex, false).GroupBy(x => x).Count();
+      return preprocessingData.GetValues<T>(columnIndex).GroupBy(x => x).Count();
     }
 
@@ -179,9 +179,9 @@
     }
 
-    private IEnumerable<double> GetDateTimeAsSeconds(int columnIndex, bool considerSelection) {
+    private IEnumerable<double> GetDateTimeAsSeconds(int columnIndex, bool considerSelection = false) {
       return GetValuesWithoutNaN<DateTime>(columnIndex, considerSelection).Select(x => (double)x.Ticks / TimeSpan.TicksPerSecond);
     }
 
-    private IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection) {
+    private IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection = false) {
       return searchLogic.GetValuesWithoutNaN<T>(columnIndex, considerSelection);
     }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IManipulationLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IManipulationLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IManipulationLogic.cs	(revision 10811)
@@ -28,9 +28,9 @@
     void ReOrderToIndices(IList<Tuple<int, int>> indices);
     void ShuffleToIndices(IList<System.Tuple<int, int>> indices);
-    void ReplaceIndicesByAverageValue(IDictionary<int, IList<int>> cells, bool considerSelection);
+    void ReplaceIndicesByAverageValue(IDictionary<int, IList<int>> cells, bool considerSelection = false);
     void ReplaceIndicesByLinearInterpolationOfNeighbours(IDictionary<int, IList<int>> cells);
-    void ReplaceIndicesByMedianValue(IDictionary<int, IList<int>> cells, bool considerSelection);
-    void ReplaceIndicesByMostCommonValue(IDictionary<int, IList<int>> cells, bool considerSelection);
-    void ReplaceIndicesByRandomValue(IDictionary<int, IList<int>> cells, bool considerSelection);
+    void ReplaceIndicesByMedianValue(IDictionary<int, IList<int>> cells, bool considerSelection = false);
+    void ReplaceIndicesByMostCommonValue(IDictionary<int, IList<int>> cells, bool considerSelection = false);
+    void ReplaceIndicesByRandomValue(IDictionary<int, IList<int>> cells, bool considerSelection = false);
     void ReplaceIndicesByValue(IDictionary<int, IList<int>> cells, string value);
     void ReplaceIndicesByValue<T>(int columnIndex, IEnumerable<int> rowIndices, T value);
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs	(revision 10811)
@@ -37,6 +37,6 @@
 
     [Obsolete("use the index based variant, is faster")]
-    IList<T> GetValues<T>(string variableName, bool considerSelection);
-    IList<T> GetValues<T>(int columnIndex, bool considerSelection);
+    IList<T> GetValues<T>(string variableName, bool considerSelection = false);
+    IList<T> GetValues<T>(int columnIndex, bool considerSelection = false);
 
     void SetValues<T>(int columnIndex, IList<T> values);
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/ISearchLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/ISearchLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/ISearchLogic.cs	(revision 10811)
@@ -39,5 +39,5 @@
     bool IsMissingValue(int columnIndex, int rowIndex);
 
-    IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection);
+    IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection = false);
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IStatisticsLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IStatisticsLogic.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IStatisticsLogic.cs	(revision 10811)
@@ -33,15 +33,15 @@
     int GetRowMissingValueCount(int rowIndex);
 
-    T GetMin<T>(int columnIndex, bool considerSelection) where T : IComparable<T>;
-    T GetMax<T>(int columnIndex, bool considerSelection) where T : IComparable<T>;
+    T GetMin<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T>;
+    T GetMax<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T>;
 
-    double GetMedian(int columnIndex, bool considerSelection);
-    double GetAverage(int columnIndex, bool considerSelection);
-    DateTime GetMedianDateTime(int columnIndex, bool considerSelection);
-    DateTime GetAverageDateTime(int columnIndex, bool considerSelection);
+    double GetMedian(int columnIndex, bool considerSelection = false);
+    double GetAverage(int columnIndex, bool considerSelection = false);
+    DateTime GetMedianDateTime(int columnIndex, bool considerSelection = false);
+    DateTime GetAverageDateTime(int columnIndex, bool considerSelection = false);
 
     double GetStandardDeviation(int columnIndex);
     double GetVariance(int columnIndex);
-    T GetMostCommonValue<T>(int columnIndex, bool considerSelection);
+    T GetMostCommonValue<T>(int columnIndex, bool considerSelection = false);
     int GetDifferentValuesCount<T>(int columnIndex);
 
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs	(revision 10810)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/PreprocessingTransformator.cs	(revision 10811)
@@ -54,5 +54,5 @@
         int colIndex = preprocessingData.GetColumnIndex(transformation.Column);
 
-        var originalData = preprocessingData.GetValues<double>(colIndex, false);
+        var originalData = preprocessingData.GetValues<double>(colIndex);
         var transformedData = ApplyDoubleTransformation(transformation, originalData, out success);
         if (!success) return;